/* System	: 񑫕s{bg(walk)
* File		: led.c
* function	: LED\
* Version	: 1.0
* Date		: 2019/5/7
* CPU		: RL78/G12 ROM:16KB RAM:1.5KB fCLK:24MHz
* IDE		: CS+ for CC V6.01.00 [01 Dec 2017]
* Programmer	: Hajime Sugiyama
* Note		: */

/* @\WX^iSFRjւ̃ANZXLqgp(RL78/R5F1026A) */
#include "iodefine.h"
#include "led.h"

#define LIGHT_ON 0U							/* LED _ */
#define LIGHT_OFF 1U							/* LED  */

#define BLINK_TIME 6							/* 0.12b = 20ms ~ 13 */
#define PULSE_ON_TIME 5							/* 0.1b = 20ms ~ 5  */
#define PULSE_OFF_TIME 70/* 1.4b = 20ms ~ 70*/

enum LED_OUTPUT led_out = LED_OFF;					/* LED\w */

/* LED\䏉jbg (SE13) */
void led_initialize(void){
	P1_bit.no4 = LIGHT_OFF;						/* |[g14̏o͂LEDHigh(1)ɐݒ */
	PMC1_bit.no4 = 0U;						/* |[g14fW^o͂ɐݒ */
	PM1_bit.no4 = 0U;						/* |[g14o͂ɐݒ */
}

/* LED\䏈jbg (LED14) */
void led(void){
	static unsigned int blink_counter = 0;
	static unsigned int off_counter = 0;
	switch(led_out){
		case LED_OFF:						/* LED */
			P1_bit.no4 = LIGHT_OFF;				/* |[g14̏o͂Low(0)ɐݒ */
			blink_counter = 0;				/* _ŊJn]邽 */
			break;
		case LED_ON:						/* LED_ */
			P1_bit.no4 = LIGHT_ON;				/* |[g14̏o͂Low(0)ɐݒ */
			blink_counter = 0;				/* _ŊJn]邽 */
			break;
		case LED_BLINK:						/* LED_ */
			/* 0.5bLED̓_Eؑւ */
			if(blink_counter > 0){				/* JE^0傫 */
				blink_counter = blink_counter - 1;	/* JE^JEg_E */
			}else{						/* JE^0ɂȂ */
				P1_bit.no4 = ~P1_bit.no4;		/* LEDo͂𔽓]i̓_j */
				blink_counter = BLINK_TIME;		/* JE^0.5bɐݒ */
			}
			break;
		case LED_PULSE:						/* LEDpX_ */
			if(blink_counter > 0){				/* _(0.1s) */
				blink_counter = blink_counter - 1;
				P1_bit.no4 = LIGHT_ON;
			}else if(off_counter > 0){			/* LED */
				off_counter = off_counter -1;		/* (1.4s) */
				P1_bit.no4 = LIGHT_OFF;
			}else{
				blink_counter = PULSE_ON_TIME;		/* pX_Ԑݒ */
				off_counter = PULSE_OFF_TIME;		/* Ԑݒ */
			}
			break;
	}
}
