/* System	: 񑫕s{bg(walk)
* File		: sequence.c
* function	: sV[PX
* Version	: 1.0
* Date		: 2019/5/7
* CPU		: RL78/G12 ROM:16KB RAM:1.5KB fCLK:24MHz
* IDE		: CS+ for CC V6.01.00 [01 Dec 2017]
* Programmer	: Hajime Sugiyama
* Note		: */

#include "unit_sequence_data.h"
#include "unit_sequence.h"
#include "sequence.h"

/* Jϐ */
enum WALKINGORDEREVENT walking_order_event = NO_EVENT;	/* swCxg */
enum WALKINGORDEREVENT walking_order_event_memory = NO_EVENT;/* swCxgL */

__f_s f_s = {1,0};					/* sV[PXtO */

static int s16_counter =0;				/* E~ */
static int s16_count_target = STOP_COUNTING;		/* ڕWE~ */
int s16_count_target_request = STOP_COUNTING;		/* vڕWE~ */

/* s */
enum WALKINGSTATE {
	STANDBY = 0,					 /* ҋ@ */
	FORWARD,					 /* Oi */
	ROTATERIGHT,					 /* E] */
	BACKWARD,					 /*  */
	ROTATELEFT,					 /* ] */
	DANCE						 /* _X */
};
static enum WALKINGSTATE walking_state = STANDBY;	/* sԕϐ */

/* Oi̕sXebv̏ */
enum FORWARDSTATE {
	FORWARD_FIRSTSTEP_R = 0,			/* OiJniEOցj */
	FORWARD_FIRSTSTEP_L,				/* OiJniOցj */
	FORWARD_L,					/* OipiOցj */
	FORWARD_R,					/* OipiEOցj */
	FORWARD_BREAK_L,				/* OiIij */
	FORWARD_BREAK_R					/* OiIiEj */
};
static enum FORWARDSTATE forward_state = FORWARD_FIRSTSTEP_R;/* sFOiԕϐ	  */

/* E]̕sXebv̏ */
enum ROTATERSTATE {
	ROTATER_FIRSTSTEP_L = 0,			/* E]Jniグj */
	ROTATER_FIRSTSTEP_R,				/* E]JniEグj */
	ROTATER_R,					/* E]piEグj */
	ROTATER_L,					/* E]piグj */
	ROTATER_BREAK_L,				/* E]Iij */
	ROTATER_BREAK_R					/* E]IiEj */
};
static enum ROTATERSTATE rotater_state = ROTATER_FIRSTSTEP_R;/* sFE]ԕϐ */

/* ނ̕sXebv̏ */
enum BACKWARDSTATE {
	BACKWARD_FIRSTSTEP_R = 0,			/* ފJniEցj */
	BACKWARD_FIRSTSTEP_L,				/* ފJniցj */
	BACKWARD_L,					/* ތpiցj */
	BACKWARD_R,					/* ތpiEցj */
	BACKWARD_BREAK_L,				/* ޏIij */
	BACKWARD_BREAK_R				/* ޏIiEj */
};
static enum BACKWARDSTATE backward_state = BACKWARD_FIRSTSTEP_R;/* sFOiԕϐ	  */

/* ]̕sXebv̏ */
enum ROTATELSTATE {
	ROTATEL_FIRSTSTEP_L = 0,			/* ]Jniグj */
	ROTATEL_FIRSTSTEP_R,				/* ]JniEグj */
	ROTATEL_R,					/* ]piEグj */
	ROTATEL_L,					/* ]piグj */
	ROTATEL_BREAK_R,				/* ]IiEj */
	ROTATEL_BREAK_L					/* ]Iij */
};
static enum ROTATELSTATE rotatel_state = ROTATEL_FIRSTSTEP_L;/* sF]ԕϐ */

static void execute_standby(void);			/* ~Ԑ */
static void execute_forward(void);			/* OiԐ */
static void execute_rotateright(void);			/* E]Ԑ */
static void execute_backward(void);			/* ޏԐ */
static void execute_rotateleft(void);			/* ]Ԑ */
static void execute_dance(void);			/* _XԐ */

static void forward_nextstep_is_r_exe(void);		/* OiXebvE */
static void forward_nextstep_is_l_exe(void);		/* OiXebv */
static void rotater_nextstep_is_r_exe(void);		/* E]XebvE */
static void rotater_nextstep_is_l_exe(void);		/* E]Xebv */
static void backward_nextstep_is_r_exe(void);		/* ޒXebvE */
static void backward_nextstep_is_l_exe(void);		/* ޒXebv */
static void rotatel_nextstep_is_r_exe(void);		/* ]XebvE */
static void rotatel_nextstep_is_l_exe(void);		/* ]Xebv */

/* sV[PX䏈jbg */
void sequence_control(void){
	switch(walking_state){				/* s */
		case STANDBY:				/* sԁF~ */
			execute_standby();		/* ~Ԑ */
			break;
		case FORWARD:				/* sԁFOi */
			if(f_us.complete == 1U){	/* PʃXebvV[PX */
				f_us.complete = 0U;
				execute_forward();	/* OiԐ */
			}
			break;
		case ROTATERIGHT:			/* sԁFE] */
			if(f_us.complete == 1){		/* PʃXebvV[PX */
				f_us.complete = 0;
				execute_rotateright();	/* E]Ԑ */
			}
			break;
		case BACKWARD:				/* sԁF */
			if(f_us.complete == 1){		/* PʃXebvV[PX */
				f_us.complete = 0;
				execute_backward();	/* ޏԐ */
			}
			break;
		case ROTATELEFT:			/* sԁF] */
			if(f_us.complete == 1){		/* PʃXebvV[PX */
				f_us.complete = 0;
				execute_rotateleft();	/* ]Ԑ */
			}
			break;
		case DANCE:				/* sԁF_X */
			if(f_us.complete == 1){		/* PʃXebvV[PX */
				f_us.complete = 0;
				execute_dance();	/* _XԐ */
			}
			break;
	}
}

/* ~Ԑ䏈jbg */
static void execute_standby(void){
	/* ݒ ~ 0.5 b ~ */
	if(s16_count_target != STOP_COUNTING){
		/* JEg𗘗pꍇis쏇sj */
		if(s16_counter < s16_count_target){	/* ~ԃJEgAbv */
			s16_counter++;
			if(s16_counter == s16_count_target){/* ~ԓB */
				f_s.complete = 1U;	/* sXebvV[PXi~ԁj */
			}
		}
	}else{
		/* JEg𗘗pȂꍇiV[PXvOsȊOj */
		/* Lsw΃Cxgs */
		if(walking_order_event_memory != NO_EVENT){
			walking_order_event = walking_order_event_memory;
			walking_order_event_memory = NO_EVENT;
		}
	}
	switch(walking_order_event){			/* swCxg */
		case FORWARD_EVENT:			/* Oi */
			/* OiJniEOj */
			sequence_shift_preprocess(u16_forward_firststep_right,c_forward_firststep_right);/* (BD1,2,5) */
			walking_state = FORWARD;
			forward_state = FORWARD_FIRSTSTEP_R;
			s16_count_target = s16_count_target_request;
			s16_counter = 0;
			break;
		case RIGHT_EVENT:			/* E] */
			/* E]JniEグj */
			sequence_shift_preprocess(u16_rotate_right_firststep_right,c_rotate_right_firststep_right);/* (BD1,2,5) */
			walking_state = ROTATERIGHT;
			rotater_state = ROTATER_FIRSTSTEP_R;
			s16_count_target = s16_count_target_request;
			s16_counter = 0;
			break;
		case BACKWARD_EVENT:			/*  */
			/* ފJniEցj */
			sequence_shift_preprocess(u16_backward_firststep_right,c_backward_firststep_right);/* (BD1,2,5) */
			walking_state = BACKWARD;
			backward_state = BACKWARD_FIRSTSTEP_R;
			s16_count_target = s16_count_target_request;
			s16_counter = 0;
			break;
		case LEFT_EVENT:			/* ] */
			/* ]Jniグցj */
			sequence_shift_preprocess(u16_rotate_left_firststep_left,c_rotate_left_firststep_left);/* (BD1,2,5) */
			walking_state = ROTATELEFT;
			rotatel_state = ROTATEL_FIRSTSTEP_L;
			s16_count_target = s16_count_target_request;
			s16_counter = 0;
			break;
		case DANCE_EVENT:			/* _X */
			sequence_shift_preprocess(u16_dance,c_dance);/* (BD1,2,5) */
			walking_state = DANCE;
			s16_count_target = s16_count_target_request;
			s16_counter = 0;
			break;
		case STOP_EVENT:			/* ~ */
			s16_count_target = s16_count_target_request;
			s16_counter = 0;
			if(s16_count_target == STOP_COUNTING){
				/* JEg𗘗pȂꍇis쏇sȊOj */
				/* sɕsV[PXtO𗧂Ă */
				f_s.complete =1U;
			}
			break;
		case NO_EVENT:
			/* ȉ̂breakȗ */
		default:
			break;
	}
	walking_order_event = NO_EVENT;			/* swCxg */
}

/* OiԐ䏈jbg */
static void execute_forward(void){
	switch(forward_state){
		case FORWARD_FIRSTSTEP_R:		/* OiJniEOցj */
			forward_nextstep_is_l_exe();
			break;
		case FORWARD_FIRSTSTEP_L:		/* OiJniOցj */
			forward_nextstep_is_r_exe();
			break;
		case FORWARD_L:				/* OipiOցj */
			forward_nextstep_is_r_exe();
			break;
		case FORWARD_R:				/* OipiEOցj */
			forward_nextstep_is_l_exe();
			break;
		case FORWARD_BREAK_L:			/* OiIij */
			/* E~(FORWARD_BREAK_R)Ɠ̂breakȗ */
		case FORWARD_BREAK_R:			/* OiIiEj */
			if(s16_count_target != STOP_COUNTING){
				f_s.complete = 1U;	/* sV[PX */
			}else if((walking_order_event != NO_EVENT) && (walking_order_event != FORWARD_EVENT)){
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
			}
			walking_state = STANDBY;	/* ҋ@iz[|WVj */
			break;
	}
}

/* OiXebvE䏈jbg */
static void forward_nextstep_is_r_exe(void){
	if(s16_count_target == STOP_COUNTING){
		switch(walking_order_event){
			case STOP_EVENT:
			/* ȉ̂breakȗ */
			case RIGHT_EVENT:
			case BACKWARD_EVENT:
			case LEFT_EVENT:
			case DANCE_EVENT:
				/* swCxgLAOiIiEj */
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
				sequence_shift_preprocess(u16_forward_break_right,c_forward_break_right);/* (BD1,2,5) */
				walking_state = FORWARD;
				forward_state = FORWARD_BREAK_R;
				break;
			default:
				/* OipiEOցj */
				sequence_shift_preprocess(u16_forward_right,c_forward_right);/* (BD1,2,5) */
				walking_state = FORWARD;
				forward_state = FORWARD_R;
				break;
		}
	}else if((++s16_counter >= s16_count_target)	/* ڕWB */
			|| (walking_order_event == STOP_EVENT)){/* swF~Cxg */
		/* OiIiEj */
		sequence_shift_preprocess(u16_forward_break_right,c_forward_break_right);/* (BD1,2,5) */
		walking_state = FORWARD;
		forward_state = FORWARD_BREAK_R;
	}else{
		/* OipiEOցj */
		sequence_shift_preprocess(u16_forward_right,c_forward_right);/* (BD1,2,5) */
		walking_state = FORWARD;
		forward_state = FORWARD_R;
	}
}

/* OiXebv䏈jbg */
static void forward_nextstep_is_l_exe(void){
	if(s16_count_target == STOP_COUNTING){
		switch(walking_order_event){
			case STOP_EVENT:
			/* ȉ̂breakȗ */
			case RIGHT_EVENT:
			case BACKWARD_EVENT:
			case LEFT_EVENT:
			case DANCE_EVENT:
				/* swCxgLAOiIij */
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;/* swCxg */
				sequence_shift_preprocess(u16_forward_break_left,c_forward_break_left);/* (BD1,2,5) */
				walking_state = FORWARD;
				forward_state = FORWARD_BREAK_L;
				break;
			default:
				/* OipiOցj */
				sequence_shift_preprocess(u16_forward_left,c_forward_left);/* (BD1,2,5) */
				walking_state = FORWARD;
				forward_state = FORWARD_L;
				break;
		}
	}else if((++s16_counter >= s16_count_target)	/* ڕWB */
			|| (walking_order_event == STOP_EVENT)){/* swF~Cxg */
		/* OiIij */
		sequence_shift_preprocess(u16_forward_break_left,c_forward_break_left);/* (BD1,2,5) */
		walking_state = FORWARD;
		forward_state = FORWARD_BREAK_L;
	}else{
		/* OipiOցj */
		sequence_shift_preprocess(u16_forward_left,c_forward_left);/* (BD1,2,5) */
		walking_state = FORWARD;
		forward_state = FORWARD_L;
	}
}

/* E]Ԑ䏈jbg */
static void execute_rotateright(void){
	switch(rotater_state){
		case ROTATER_FIRSTSTEP_L:		/* E]Jniグj */
			rotater_nextstep_is_r_exe();
			break;
		case ROTATER_FIRSTSTEP_R:		/* E]JniEグj */
			rotater_nextstep_is_l_exe();
			break;
		case ROTATER_L:				/* E]piグj */
			rotater_nextstep_is_r_exe();
			break;
		case ROTATER_R:				/* E]piEグj */
			rotater_nextstep_is_l_exe();
			break;
		case ROTATER_BREAK_L:			/* E]~ij */
			/* E~(ROTATER_BREAK_R)Ɠ̂breakȗ */
		case ROTATER_BREAK_R:			/* E]~iEj */

			if(s16_count_target != STOP_COUNTING){
				f_s.complete = 1U;	/* sV[PX */
			}else if((walking_order_event != NO_EVENT) && (walking_order_event != RIGHT_EVENT)){
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
			}
			walking_state = STANDBY;	/* ҋ@iz[|WVj */
			break;
	}
}

/* E]XebvE䏈jbg */
static void rotater_nextstep_is_r_exe(void){
	if(s16_count_target == STOP_COUNTING){
		switch(walking_order_event){
			case STOP_EVENT:
			/* ȉ̂breakȗ */
			case FORWARD_EVENT:
			case LEFT_EVENT:
			case BACKWARD_EVENT:
			case DANCE_EVENT:
				/* swCxgLAE]IiEj */
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
				sequence_shift_preprocess(u16_rotate_right_break_right,c_rotate_right_break_right);/* (BD1,2,5) */
				walking_state = ROTATERIGHT;
				rotater_state = ROTATER_BREAK_R;
				break;
			default:
				/* E]piEグj */
				sequence_shift_preprocess(u16_rotate_right_right,c_rotate_right_right);/* (BD1,2,5) */
				walking_state = ROTATERIGHT;
				rotater_state = ROTATER_R;
				break;
		}
	}else if((++s16_counter >= s16_count_target)	/* ڕWB */
			|| (walking_order_event == STOP_EVENT)){/* ~Cxg */
		/* E]~iEj */
		sequence_shift_preprocess(u16_rotate_right_break_right,c_rotate_right_break_right);/* (BD1,2,5) */
		walking_state = ROTATERIGHT;
		rotater_state = ROTATER_BREAK_R;
	}else{
		/* E]piEグj */
		sequence_shift_preprocess(u16_rotate_right_right,c_rotate_right_right);/* (BD1,2,5) */
		walking_state = ROTATERIGHT;
		rotater_state = ROTATER_R;
	}
}

/* E]Xebv䏈jbg(BD1,2,5) */
static void rotater_nextstep_is_l_exe(void){
	if(s16_count_target == STOP_COUNTING){
		switch(walking_order_event){
			case STOP_EVENT:
			/* ȉ̂breakȗ */
			case FORWARD_EVENT:
			case BACKWARD_EVENT:
			case LEFT_EVENT:
			case DANCE_EVENT:
				/* swCxgLAE]Iij */
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
				sequence_shift_preprocess(u16_rotate_right_break_left,c_rotate_right_break_left);/* (BD1,2,5) */
				walking_state = ROTATERIGHT;
				rotater_state = ROTATER_BREAK_L;
				break;
			default:
				/* E]piグj */
				sequence_shift_preprocess(u16_rotate_right_left,c_rotate_right_left);/* (BD1,2,5) */
				walking_state = ROTATERIGHT;
				rotater_state = ROTATER_L;
				break;
		}
	}else if((++s16_counter >= s16_count_target)	/* ڕWB */
			|| (walking_order_event == STOP_EVENT)){/* swF~Cxg */
		/* E]Iij */
		sequence_shift_preprocess(u16_rotate_right_break_left,c_rotate_right_break_left);/* (BD1,2,5) */
		walking_state = ROTATERIGHT;
		rotater_state = ROTATER_BREAK_L;
	}else{
		/* E]piグj */
		sequence_shift_preprocess(u16_rotate_right_left,c_rotate_right_left);/* (BD1,2,5) */
		walking_state = ROTATERIGHT;
		rotater_state = ROTATER_L;
	}
}

/* ޏԐ䏈jbg */
static void execute_backward(void){
	switch(backward_state){
		case BACKWARD_FIRSTSTEP_R:		/* ފJniEցj */
			backward_nextstep_is_l_exe();
			break;
		case BACKWARD_FIRSTSTEP_L:		/* ފJniցj */
			backward_nextstep_is_r_exe();
			break;
		case BACKWARD_L:			/* ތpiցj */
			backward_nextstep_is_r_exe();
			break;
		case BACKWARD_R:			/* ތpiEցj */
			backward_nextstep_is_l_exe();
			break;
		case BACKWARD_BREAK_L:			/* ޏIij */
			/* E~(BACKWARD_BREAK_R)Ɠ̂breakȗ */
		case BACKWARD_BREAK_R:			/* ޏIiEj */
			if(s16_count_target != STOP_COUNTING){
				f_s.complete = 1U;	/* sV[PX */
			}else if((walking_order_event != NO_EVENT) && (walking_order_event != BACKWARD_EVENT)){
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
			}
			walking_state = STANDBY;	/* ҋ@iz[|WVj */
			break;
	}
}

/* ޒXebvE䏈jbg */
static void backward_nextstep_is_r_exe(void){
	if(s16_count_target == STOP_COUNTING){
		switch(walking_order_event){
			case STOP_EVENT:
			/* ȉ̂breakȗ */
			case FORWARD_EVENT:
			case RIGHT_EVENT:
			case LEFT_EVENT:
			case DANCE_EVENT:
				/* swCxgLAޏIiEj */
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
				sequence_shift_preprocess(u16_backward_break_right,c_backward_break_right);/* (BD1,2,5) */
				walking_state = BACKWARD;
				backward_state = BACKWARD_BREAK_R;
				break;
			default:
				/* ތpiEցj */
				sequence_shift_preprocess(u16_backward_right,c_backward_right);/* (BD1,2,5) */
				walking_state = BACKWARD;
				backward_state = BACKWARD_R;
				break;
		}
	}else if((--s16_counter <= s16_count_target)	/* ڕWB */
		|| (walking_order_event == STOP_EVENT)){/* swF~Cxg */
		/* ޏIiEj */
		sequence_shift_preprocess(u16_backward_break_right,c_backward_break_right);/* (BD1,2,5) */
		walking_state = BACKWARD;
		backward_state = BACKWARD_BREAK_R;
	}else{
		/* ތpiEցj */
		sequence_shift_preprocess(u16_backward_right,c_backward_break_right);/* (BD1,2,5) */
		walking_state = BACKWARD;
		backward_state = BACKWARD_R;
	}
}

/* ޒXebv䏈jbg */
static void backward_nextstep_is_l_exe(void){
	if(s16_count_target == STOP_COUNTING){
		switch(walking_order_event){
			case STOP_EVENT:
			/* ȉ̂breakȗ */
			case FORWARD_EVENT:
			case RIGHT_EVENT:
			case LEFT_EVENT:
			case DANCE_EVENT:
				/* swCxgLAޏIij */
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
				sequence_shift_preprocess(u16_backward_break_left,c_backward_break_left);/* (BD1,2,5) */
				walking_state = BACKWARD;
				backward_state = BACKWARD_BREAK_L;
				break;
			default:
				/* ތpiցj */
				sequence_shift_preprocess(u16_backward_left,c_backward_left);/* (BD1,2,5) */
				walking_state = BACKWARD;
				backward_state = BACKWARD_L;
				break;
		}
	}else if((--s16_counter <= s16_count_target)	/* ڕWB */
		|| (walking_order_event == STOP_EVENT)){/* ~Cxg */
		/* ޏIij */
		sequence_shift_preprocess(u16_backward_break_left,c_backward_break_left);/* (BD1,2,5) */
		walking_state = BACKWARD;
		backward_state = BACKWARD_BREAK_L;
	}else{
		/* ތpiցj */
		sequence_shift_preprocess(u16_backward_left,c_backward_left);/* (BD1,2,5) */
		walking_state = BACKWARD;
		backward_state = BACKWARD_L;
	}
}

/* ]Ԑ䏈jbg */
static void execute_rotateleft(void){
	switch(rotatel_state){
		case ROTATEL_FIRSTSTEP_L:		/* ]Jniグj */
			rotatel_nextstep_is_r_exe();
			break;
		case ROTATEL_FIRSTSTEP_R:		/* ]JniEグj */
			rotatel_nextstep_is_l_exe();
			break;
		case ROTATEL_L:				/* ]piグj */
			rotatel_nextstep_is_r_exe();
			break;
		case ROTATEL_R:				/* ]piEグj */
			rotatel_nextstep_is_l_exe();
			break;
		case ROTATEL_BREAK_L:			/* ]Iij */
			/* E~(ROTATEL_BREAK_R)Ɠ̂breakȗ */
		case ROTATEL_BREAK_R:			/* ]IiEj */

			if(s16_count_target != STOP_COUNTING){
				f_s.complete = 1U;	/* sV[PX */
			}else if((walking_order_event != NO_EVENT) && (walking_order_event != LEFT_EVENT)){
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
			}
			walking_state = STANDBY;	/* ҋ@iz[|WVj */
			break;
	}
}

/* ]XebvE䏈jbg */
static void rotatel_nextstep_is_r_exe(void){
	if(s16_count_target == STOP_COUNTING){
		switch(walking_order_event){
			case STOP_EVENT:
			/* ȉ̂breakȗ */
			case FORWARD_EVENT:
			case RIGHT_EVENT:
			case BACKWARD_EVENT:
			case DANCE_EVENT:
				/* swCxgLA]IiEj */
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
				sequence_shift_preprocess(u16_rotate_left_break_right,c_rotate_left_break_right);/* (BD1,2,5) */
				walking_state = ROTATELEFT;
				rotatel_state = ROTATEL_BREAK_R;
				break;
			default:
				/* ]piEグj */
				sequence_shift_preprocess(u16_rotate_left_right,c_rotate_left_right);/* (BD1,2,5) */
				walking_state = ROTATELEFT;
				rotatel_state = ROTATEL_R;
				break;
		}
	}else if((--s16_counter <= s16_count_target)	/* ڕWB */
			|| (walking_order_event == STOP_EVENT)){/* ~Cxg */
		/* ]IiEj */
		sequence_shift_preprocess(u16_rotate_left_break_right,c_rotate_left_break_right);/* (BD1,2,5) */
		walking_state = ROTATELEFT;
		rotatel_state = ROTATEL_BREAK_R;
	}else{
		/* ]piEグj */
		sequence_shift_preprocess(u16_rotate_left_right,c_rotate_left_right);/* (BD1,2,5) */
		walking_state = ROTATELEFT;
		rotatel_state = ROTATEL_R;
	}
}

/* ]Xebv䏈jbg */
static void rotatel_nextstep_is_l_exe(void){
	if(s16_count_target == STOP_COUNTING){
		switch(walking_order_event){
			case STOP_EVENT:
			/* ȉ̂breakȗ */
			case FORWARD_EVENT:
			case RIGHT_EVENT:
			case BACKWARD_EVENT:
			case DANCE_EVENT:
				/* swCxgLA]Iij */
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
				sequence_shift_preprocess(u16_rotate_left_break_left,c_rotate_left_break_left);/* (BD1,2,5) */
				walking_state = ROTATELEFT;
				rotatel_state = ROTATEL_BREAK_L;
				break;
			default:
				/* ]piグj */
				sequence_shift_preprocess(u16_rotate_left_left,c_rotate_left_left);/* (BD1,2,5) */
				walking_state = ROTATELEFT;
				rotatel_state = ROTATEL_L;
				break;
		}
	}else if((--s16_counter <= s16_count_target)	/* ڕWB */
			|| (walking_order_event == STOP_EVENT)){/* swF~Cxg */
		/* ]Iij */
		sequence_shift_preprocess(u16_rotate_left_break_left,c_rotate_left_break_left);/* (BD1,2,5) */
		walking_state = ROTATELEFT;
		rotatel_state = ROTATEL_BREAK_L;
	}else{
		/* ]piグj */
		sequence_shift_preprocess(u16_rotate_left_left,c_rotate_left_left);/* (BD1,2,5) */
		walking_state = ROTATELEFT;
		rotatel_state = ROTATEL_L;
	}
}

/* _XԐ䏈jbg */
static void execute_dance(void){
	if(s16_count_target == STOP_COUNTING){
		switch(walking_order_event){
			case STOP_EVENT:
			/* ȉ̂breakȗ */
			case FORWARD_EVENT:
			case RIGHT_EVENT:
			case BACKWARD_EVENT:
			case LEFT_EVENT:
				/* swCxgLAҋ@Ԃ */
				walking_order_event_memory = walking_order_event;
				walking_order_event = NO_EVENT;	/* swCxg */
				walking_state = STANDBY;/* ҋ@iz[|WVj */
				break;
			default:
				/* _Xp */
				sequence_shift_preprocess(u16_dance,c_dance);/* (BD1,2,5) */
				walking_state = DANCE;
				break;
		}
	}else if((++s16_counter >= s16_count_target)	/* ڕWB */
			|| (walking_order_event == STOP_EVENT)){/* ~Cxg */
		/* ҋ@iz[|WVj */
		f_s.complete = 1U;			/* sV[PX */
		walking_state = STANDBY;
	}else{
		/* _Xp */
		sequence_shift_preprocess(u16_dance,c_dance);/* (BD5) */
		walking_state = DANCE;
	}
}
