/* System	: 񑫕s{bg(walk)
* File		: serial.c
* function	: ʐM
* Version	: 1.0
* Date		: 2019/5/7
* CPU		: RL78/G12 ROM:16KB RAM:1.5KB fCLK:24MHz
* IDE		: CS+ for CC V6.01.00 [01 Dec 2017]
* Programmer	: Hajime Sugiyama
* Note		: */

/* f[^		8rbg	 */
/* f[^]	LSB first*/
/* peB			 */
/* XgbvErbg	1rbg	 */
/* ^USB-VAϊW[(MPL2303SA) */
/* _]HoR(SE9) */

/* @\WX^iSFRjւ̃ANZXLqgp(RL78/R5F1026A) */
#include "iodefine.h"
/* jbg0̃`l0ƃ`l1̂ꂼɑEM݊֐ݒ肵܂ */
#pragma interrupt uart0_interrupt_send(vect = INTST0)	/* M݁F`l0 */
#pragma interrupt uart0_interrupt_receive(vect = INTSR0)/* M݁F`l1 */

#include "sequence_data.h"
#include "serial.h"

#define NET_DATA_SIZE	8				/* tf[^ */
#define RX_STARTCODE	0xAA				/* MpPbg̃X^[gR[h */
#define TX_STARTCODE	0xAA				/* MpPbg̃X^[gR[h */
#define ACK		0x06				/* m艞iacceptj */
#define NAK		0x15				/* ے艞ibusyj */

/* Jϐ */
struct _F_SERIAL f_serial = {1,0,0,0};			/* ʐMtO */
enum MODE_EV e_mode_event = NO_EVM;			/* 샂[hwCxg */
enum WALK_EV e_walk_event = NO_EVW;			/* swCxg */
/* ϐ */
/* MpPbgobt@iʏԐMpj */
static unsigned char uart0_tx[PACKET_SIZE] = {TX_STARTCODE,0,0,0,0,0,0,0,0,0,0,0};
/* MpPbgobt@i샂[hm艞pj */
static unsigned char uart0_tx_fix[PACKET_SIZE] = {TX_STARTCODE,0,0,0,0,0,0,0,0,0,0,0};
/* tf[^i[obt@ */
static unsigned char u8_rx_buff[NET_DATA_SIZE]
	= {0,0,0,0,0,0,0,0};
/* Mf[^
@@0x01:샂[hύXw
@@0x04:sw
@@0x08:s쏇f[^ */
static unsigned char u8_rx_datatype = 0x01U;		/* Mf[^ */
static unsigned char u8_rx_packetno = 0U;		/* MpPbgԍ */
/* Mobt@|C^F֐̈ŕK邽ߏlݒ肵Ȃ */
static unsigned char * u8p_uart0_tx_address;
static unsigned char u8_uart0_tx_count = 0U;		/* MJE^ */
static unsigned char u8_rec_sequence_number = 0U;	/* Ms쏇f[^̐ */

union SEQUENCE{	/* V[PXf[^\́@́@pPbgz@ϊ */
	unsigned char u8_dummy[2 * SQ_NO_MAX];		/* p̏̂߂̑pz */
	struct SEQDATA u8_seqpair[SQ_NO_MAX];		/* s쏇f[^QƗp */
	unsigned char u8_seq[SQ_NO_MAX / 4][NET_DATA_SIZE];/* ʐMf[^i[p */
};
/* Ms쏇f[^ꎞLz */
static union SEQUENCE sequence_buf = {
	0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U,
	0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U,
	0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U,
	0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U,
	0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U,
	0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U,
	0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U,
	0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U
};

/* ֐ */
static void uart0_send(unsigned char * tx_buf);		/* MJn */
static void uart0_receiveend(void);			/* M */

/* VAMHjbg	UART00FM	UART01FM */
void uart0_initialize(void){
	/* M|[g̐ݒ (SE8) */
	PIOR |= 0x02U;					/* TxD0,RxD0P60,P61֊t */
	PM6 |= 0x02U;					/* RxD0(PM61:bit1)̓[h */
	P6 |= 0x01U;					/* |[gP60̏o̓b`̒lhPh */
	PM6 &= 0xFEU;					/* RxD0(PM60:bit0)o̓[h */

	/* VAEACEjbgOփNbN (SE8) */
	SAU0EN = 1U;	/* VAEACEjbgOփNbN */
	__nop();
	__nop();
	__nop();
	__nop();
	SPS0 = 0x0044U;	/* CK00ACK01Ƃ1.5MHzɐݒ(VAENbNIWX^O) */

	/* Mjbg̐ݒ菉	UART00FM	UART01FM (SE5,8) */
	ST0 |= 0x0003U;					/* M~(`l01)(VA`l~WX^0) */
	STMK0 = 1U;					/* UART0M̓]݂֎~ */
	STIF0 = 0U;					/* UART0M̊ݗvtONA */
	SRMK0 = 1U;					/* UART0M̓]݂֎~ */
	SRIF0 = 0U;					/* UART0M̊ݗvtONA */
	SREMK0 = 1U;					/* ʐMG[݂֎~(t[~O^peB^I[oEG[) */
	SREIF0 = 0U;					/* ʐMG[ݗvtONA */

	STPR10 = 1U;					/* UART0MD揇ʂɐݒ */
	STPR00 = 1U;

	SRPR10 = 1U;					/* UART0MD揇ʂɐݒ */
	SRPR00 = 1U;

	SMR00 = 0x0022U;				/* CK00I,UART[h,] */
	SCR00 = 0x8397U;				/* M̂,f[^8,LSB first,peB,XgbvErbg1,G[݋֎~ */
	SDR00 = 0x9A00U;				/* ݒ9615bps( fMCK:1.5MHz  fCLK:24MHz) (SE6,7) */
	NFEN0 |= 0x01U;					/* RxD0[qɲޥ̨gp */
	SIR01 = 0x0007U;				/* t[~O^peB^I[oEG[EtÕNA */
	SMR01 = 0x0162U;				/* CK00I,rbg],UART[h,] (SE9) */
	SCR01 = 0x4397U;				/* M̂,f[^8,LSB first,peB,XgbvErbg1,G[݋֎~ */
	SDR01 = 0x9A00U;				/* ݒ9615bps( fMCK:1.5MHz  fCLK:24MHz) (SE6,7) */
	SO0 &= ~0x0001U;				/* VAf[^o͒lg0h */
	SOL0 |= 0x0001U;				/* ʐMf[^̃x́A]o(0:highA1:low) (SE9) */
	SOE0 |= 0x0001U;				/* VAʐMɂo͋ */
}

/* VAʐMJnjbg */
void uart0_start(void){
	SOE0 |= 0x0001U;				/* VAʐMɂo͋ */
	SS0 |= 0x0003U;					/* UART0̎EM */
	STIF0 = 0U;					/* MݗvtONA */
	SRIF0 = 0U;					/* MݗvtONA */
	STMK0 = 0U;					/* M݂ */
	SRMK0 = 0U;					/* M݂ */
}

/* Mjbg */
static void uart0_interrupt_receive(void){
	/* M */
	/* X^[gR[h擾,f[^ގ擾,pPbgԍ擾,tf[^擾,BCC擾,MG[ */
	enum RX_STATE {START,CAT,PACNO,PACDAT,BCC,RXERR};
	static enum RX_STATE e_rx_state = START;	/* M */
	static unsigned char u8_rx_data = 0U;		/* Mf[^obt@(1byte) */
	static unsigned char u8_rx_datano = 0U;		/* tf[^JE^ */
	static unsigned int u16_err_type = 0U;		/* MG[ */
	static unsigned char u8_rx_checkcode = 0U;	/* MBCCpobt@ */

	u16_err_type = (unsigned char)(SSR01 & 0x0007U);/* UART01MG[̌o */
	SIR01 = (unsigned int)u16_err_type;		/* MG[tÕNA */
	if(u16_err_type != 0U){				/* MG[͎MG[Ԃɂ */
		e_rx_state = RXERR;
	}

	u8_rx_data = (unsigned char)RXD0;		/* Mf[^̎擾 */
	switch(e_rx_state){				/* pPbg̉ */
		case START:				/* X^[gR[h擾҂ */
			if(u8_rx_data == RX_STARTCODE){	/* X^[gR[h擾 */
				u8_rx_checkcode = u8_rx_data;/* MBCCZo */
				e_rx_state = CAT;	/* f[^ގ擾 */
			}
			break;
		case CAT:				/* f[^ގ擾 */
			u8_rx_datatype = u8_rx_data;	/* f[^ދL */
			u8_rx_checkcode ^= u8_rx_data;	/* MBCCZo */
			e_rx_state = PACNO;		/* pPbgԍ擾 */
			break;
		case PACNO:				/* pPbgԍ擾 */
			u8_rx_checkcode ^= u8_rx_data;	/* MBCCZo */
			u8_rx_packetno = u8_rx_data;	/* pPbgԍL */
			u8_rx_datano = 0;		/* tf[^JE^ */
			e_rx_state = PACDAT;		/* tf[^擾 */
			break;
		case PACDAT:				/* tf[^擾(8byte) */
			u8_rx_checkcode ^= u8_rx_data;	/* MBCCZo */
			u8_rx_buff[u8_rx_datano] = u8_rx_data;/* tf[^L */
			if(++u8_rx_datano >= NET_DATA_SIZE){/* tf[^擾H */
				e_rx_state = BCC;	/* BCC擾 */
			}
			break;
		case BCC:				/* BCC擾 */
			/* ubN`FbNR[h(BCC:peB(XOR))̎擾`MJn */
			if(u8_rx_data == u8_rx_checkcode){/* MBCCv (SE1) */
				uart0_receiveend();	/* M */
			}
			e_rx_state = START;		/* X^[gR[h擾҂ */
			break;
		case RXERR:				/* MG[ */
			e_rx_state = START;		/* X^[gR[h擾҂ */
			break;
		default:
			e_rx_state = START;		/* X^[gR[h擾҂ */
			break;
	}
}

/* MjbgipPbǵECxgsEs쏇f[^LEMf[^쐬j */
static void uart0_receiveend(void){
	auto unsigned char u8_counter = 0U;		/* JEgpϐ */
	static unsigned char u8_rx_packetno_next = 0U;	/* M҂pPbgԍ */
	/* Mobt@ */
	auto unsigned char u8_tx_checkcode = 0U;	/* MBCCpobt@ */
	auto unsigned char f_tx = 1U;			/* MtO */
	uart0_tx[1] = u8_rx_datatype;			/* f[^ސݒ */
	uart0_tx[2] = u8_rx_packetno;			/* pPbgԍݒ */
	/* f[^ʂƂ̏ */
	switch(u8_rx_datatype){
		case 0x01U:				/* 샂[hύXw */
			/* 샂[hύXwCxg̔s */
			switch(u8_rx_buff[0]){		/* 샂[h */
				case 0x01U:		/* vO샂[h */
					e_mode_event = BUILTIN_EVM;
					break;
				case 0x04U:		/* MvO샂[h */
					e_mode_event = RX_EVM;
					break;
				case 0x10U:		/* p\R샂[h */
					e_mode_event = PC_EVM;
					break;
				default:		/* ̑ */
					f_tx = 0U;	/* MȂ */
					break;
			}
			if(f_serial.mode_changeable == 1U){/* 샂[hύX */
				f_serial.mode_changeable = 0U;
				/* Mf[^̍쐬 */
				uart0_tx[3] = u8_rx_buff[0];/* 샂[h */
			}else{				/* 샂[hύX */
				uart0_tx[3] = NAK;	/* ے艞 */
				u8_tx_checkcode = 0;
				/* 샂[hύX̍m艞pPbg̎O쐬 */
				for(u8_counter = 0;u8_counter < (PACKET_SIZE - 1);u8_counter++){
					if(u8_counter != 3){
						uart0_tx_fix[u8_counter] = uart0_tx[u8_counter];
					}else{
						/* 샂[hL */
						uart0_tx_fix[u8_counter] = u8_rx_buff[0];
					}
					u8_tx_checkcode ^= uart0_tx_fix[u8_counter];
				}
				uart0_tx_fix[PACKET_SIZE - 1] = u8_tx_checkcode;
				f_serial.respose_pending = 1U;	/* m艞M */
			}
			break;
		case 0x04U:				/* sw */
			if(f_serial.walking_motion_changeable == 1U){
				/* sw̔s */
				switch(u8_rx_buff[0]){	/*  */
					case 0x0FU:	/* ~ */
						e_walk_event = STOP_EVW;
						break;
					case 0x01U:	/* Oi */
						e_walk_event = FORWARD_EVW;
						break;
					case 0x02U:	/* E] */
						e_walk_event = RIGHT_EVW;
						break;
					case 0x04U:	/*  */
						e_walk_event = BACKWARD_EVW;
						break;
					case 0x08U:	/* ] */
						e_walk_event = LEFT_EVW;
						break;
					case 0x06U:	/* _X */
						e_walk_event = DANCE_EVW;
						break;
					default:	/* ̑ */
						f_tx = 0U;/* MȂ */
						break;
				}
				/* Mf[^̍쐬 */
				uart0_tx[3] = u8_rx_buff[0];/*  */
			}else{
				uart0_tx[3] = NAK;	/* ے艞 */
			}
			break;
		case 0x08U: 				/* s쏇f[^M */
			/* pPbǧEMf[^̍쐬 */ 
			if(u8_rx_packetno >= (2 * SQ_NO_MAX / NET_DATA_SIZE)){	/* pPbgԍ͈͊O */
				f_tx = 0U;		/* MȂ */
			}else if((u8_rx_packetno == 0) || (u8_rx_packetno == u8_rx_packetno_next)){
				/* MipPbgԍF0`7j */
				/* s쏇f[^̊i[ */
				for(u8_counter = 0;u8_counter < NET_DATA_SIZE;u8_counter++){
					sequence_buf.u8_seq[u8_rx_packetno][u8_counter] = u8_rx_buff[u8_counter];
				}
				u8_rec_sequence_number = 4 * (u8_rx_packetno + 1);	/* Ms쏇f[^ */
				if(u8_rx_packetno < (2 * SQ_NO_MAX / NET_DATA_SIZE - 1)){
					u8_rx_packetno_next = u8_rx_packetno + 1;/* M҂pPbgԍ */
				}else{
					u8_rx_packetno_next = 0;
				}
				uart0_tx[3] = ACK;	/* M */
			}else{	/* ߹Č */
				uart0_tx[2] = u8_rx_packetno_next;/* pPbgԍ */
				uart0_tx[3] = NAK;	/* pPbg */
			}
			break;
		default:
			f_tx = 0U;			/* MȂ */
			break;
	}
	/* M */
	if(f_tx == 1U){					/* MpPbgُȂ */
		/* MBCC̎Zo (SE2) */
		u8_tx_checkcode = 0;
		for(u8_counter = 0;u8_counter < (PACKET_SIZE -1);u8_counter++){
			u8_tx_checkcode ^= uart0_tx[u8_counter];
		}
		uart0_tx[PACKET_SIZE -1] = u8_tx_checkcode;
		uart0_send(uart0_tx);			/* MJn */
	}
}

/* MJnjbg */
static void uart0_send(unsigned char * tx_buf){
	u8p_uart0_tx_address = tx_buf;			/* Mobt@̐擪AhXݒ */
	u8_uart0_tx_count = 0U;				/* MJE^NA */
	STMK0 = 1U;					/* M݂֎~ */
	/* pPbg̐擪𑗐MpVAEf[^WX^ɐݒ  MJn */
	TXD0 = u8p_uart0_tx_address[u8_uart0_tx_count];
	u8_uart0_tx_count++;				/* MJE^𑝉 */
	STMK0 = 0U;					/* M(INTST0) */
}

/* MJni[hύXj */
void uart0_send_mode_changed(void){
	uart0_send(uart0_tx_fix);
}

/* Mjbg */
static void uart0_interrupt_send(void){
	if (u8_uart0_tx_count < PACKET_SIZE){		/* Mf[^ */
		/* pPbg1 byte 𑗐MpVAEf[^EWX^ɐݒ  MJn */
		TXD0 = u8p_uart0_tx_address[u8_uart0_tx_count];
		u8_uart0_tx_count++;			/* MJE^𑝉 */
	}else{
		STMK0 = 1U;				/* M݂֎~ */
	}
}

/* Mf[^m菈jbgis쏇f[^gpOɌďoj */
/* MpPbgԍ */
void get_sequence_data(void){
	auto unsigned char u8_counter = 0U;		/* JEgpϐ */
	__DI();						/* ݋֎~ */
	/* Ms쏇f[^ȉ  s쏇f[^ȉ */
	for(u8_counter = 0;(u8_counter < u8_rec_sequence_number)
		&& (u8_counter < SQ_NO_MAX);u8_counter++){
		sequence_data[u8_counter].category = sequence_buf.u8_seqpair[u8_counter].category;
		sequence_data[u8_counter].count = sequence_buf.u8_seqpair[u8_counter].count;
	}
	__EI();						/* ݋ */
}
