/* System	: 񑫕s{bg(walk)
* File		: system.c
* function	: VXeԐ
* Version	: 1.0
* Date		: 2019/5/7
* CPU		: RL78/G12 ROM:16KB RAM:1.5KB fCLK:24MHz
* IDE		: CS+ for CC V6.01.00 [01 Dec 2017]
* Programmer	: Hajime Sugiyama
* Note		: */

#include "switch.h"
#include "led.h"
#include "serial.h"
#include "sequence.h"
#include "sequence_data.h"
#include "system.h"
#include "vb_detect.h"
#include "vb_control.h"

/* vO샂[h,MvO샂[h,p\R샂[h,drdُ탂[h */
enum OP_MODE{BUILTIN_PG,RX_PG,PC_OP,VB_FAULT};
static enum OP_MODE e_operation_mode = BUILTIN_PG;

/* vO샂[h̃R|Wbg */
/* vO~,vOs */
enum BUILTIN_MODE{BUILTIN_STP,BUILTIN_EXE};
static enum BUILTIN_MODE e_builtin_mode = BUILTIN_STP;

/* p\R샂[h̃R|Wbg */
/* p\R~,p\Rs */
enum PC_MODE{PC_STP,PC_EXE};
static enum PC_MODE e_pc_mode = PC_STP;

/* MvO샂[h̃R|Wbg */
/* MvO~,]vOs */
enum RX_MODE{RX_STP,RX_EXE};
static enum RX_MODE e_rx_mode = RX_STP;

static unsigned int sequence_counter = 0;			/* sV[PXԍ(up_counter) */

static void execute_pc_mode(void);				/* p\Rs */
static void shift_mode(enum OP_MODE to_mode);			/* 샂[hύX */
static void execute_sequence_data(struct SEQDATA *seq_data);	/* s쏇f[^s */

/* VXeԐ䏈jbg */
void system_control(void){
	switch(e_operation_mode){				/* 샂[h */
		case BUILTIN_PG:				/* vO샂[h */
			if(f_vb_alarm.abnormal == 1U){		/* drdُ (BD3,4)*/
				shift_mode(VB_FAULT);		/* drdُ탂[hւ̕ύX */
			}else if(e_mode_event == BUILTIN_EVM){	/* vO샂[hւ̕ύXv */
				shift_mode(BUILTIN_PG);		/* vO샂[hւ̕ύX */
			}else if(e_mode_event == RX_EVM){	/* MvO샂[hւ̕ύXv */
				shift_mode(RX_PG);		/* MvO샂[hւ̕ύX */
			}else if(e_mode_event == PC_EVM){	/* p\R샂[hւ̕ύXv */
				shift_mode(PC_OP);		/* p\R샂[hւ̕ύX */
			}else{
				switch(e_builtin_mode){		/* vO */
					case BUILTIN_STP:	/* vO~ */
					default:
						if(f_s.complete == 1U){	/* sV[PX */
							if(f_switch.start_stop == 1U){	/* X^[gEXgbv{^ */
								f_switch.start_stop = 0U;
								f_serial.mode_changeable = 0U;/* 샂[hύX */
								sequence_counter = 0U;	/* V[PXԍ */
								e_builtin_mode = BUILTIN_EXE;/* vOsԂ */
							}else{	/* sV[PX */
								f_serial.mode_changeable = 1U;/* 샂[hύX */
								led_out = LED_OFF;
							}
						}
						break;
					case BUILTIN_EXE:	/* vOs */
						if(f_switch.start_stop == 1U){	/* X^[gEXgbv{^ */
							f_switch.start_stop = 0U;
							walking_order_event = STOP_EVENT;/* swF~Cxgs */
							f_s.complete = 0U;
							s16_count_target_request = STOP_COUNTING;/* JEg𗘗pȂ */
							e_builtin_mode = BUILTIN_STP;/* vO~Ԃ */
						}else if(f_s.complete == 1U){	/* sV[PX */
							f_s.complete = 0U;
							execute_sequence_data((struct SEQDATA *)builtin_data);
						}
						led_out = LED_PULSE;/* LEDpX_ */
						break;
			}
			}
			break;
		case RX_PG:					/* MvO샂[h */
			if(f_vb_alarm.abnormal == 1U){		/* drdُ (BD3,4) */
				shift_mode(VB_FAULT);		/* drdُ탂[hւ̕ύX */
			}else if(e_mode_event == BUILTIN_EVM){	/* vO샂[hւ̕ύXv */
				shift_mode(BUILTIN_PG);		/* vO샂[hւ̕ύX */
			}else if(e_mode_event == RX_EVM){	/* MvO샂[hւ̕ύXv */
				shift_mode(RX_PG);		/* MvO샂[hւ̕ύX */
			}else if(e_mode_event == PC_EVM){	/* p\R샂[hւ̕ύXv */
				shift_mode(PC_OP);		/* p\R샂[hւ̕ύX */
			}else{
				switch(e_rx_mode){
					case RX_STP:		/* MvO~ */
					default:
						if(f_s.complete == 1U){	/* sV[PX */
							if(f_switch.start_stop == 1U){	/* X^[gEXgbv{^ */
								f_switch.start_stop = 0U;
								f_serial.mode_changeable = 0U;/* 샂[hύX */
								sequence_counter = 0U;	/* V[PXԍ */
								get_sequence_data();	/* Ms쏇f[^̊m */
								e_rx_mode = RX_EXE;	/* MvOsԂ */
							}else {	/* sV[PX */
								f_serial.mode_changeable = 1U;/* 샂[hύX */
								led_out = LED_OFF;	/* LED */
							}
						}
						break;
					case RX_EXE:		/* MvOs */
						if(f_switch.start_stop == 1U){/* X^[gEXgbv{^ */
							f_switch.start_stop = 0U;
							walking_order_event = STOP_EVENT;/* swF~Cxgs */
							f_s.complete = 0U;
							s16_count_target_request = STOP_COUNTING;/* JEg𗘗pȂ */
							e_rx_mode = RX_STP;	/* MvO~Ԃ */
						}else if(f_s.complete == 1U){	/* sV[PXi~j */
							f_s.complete = 0U;
							execute_sequence_data(sequence_data);
						}
						led_out = LED_PULSE;	/* LEDpX_ */
						break;
				}
			}
			break;
		case PC_OP:					/* p\R샂[h */
			if(f_vb_alarm.abnormal == 1U){		/* drdُ (BD3,4) */
				shift_mode(VB_FAULT);		/* drdُ탂[hւ̕ύXv */
			}else if(e_mode_event == RX_EVM){	/* MvO샂[hւ̕ύXv */
				shift_mode(RX_PG);		/* MvO샂[hւ̕ύX */
			}else if(e_mode_event == BUILTIN_EVM){	/* vO샂[hւ̕ύXv */
				shift_mode(BUILTIN_PG);		/* vO샂[hւ̕ύX */
			}else if(e_mode_event == PC_EVM){	/* p\R샂[hւ̕ύXv */
				shift_mode(PC_OP);		/* p\R샂[hւ̕ύX */
			}else{					/* p\R샂[h */
				switch(e_pc_mode){
					case PC_STP:		/* p\R~ */
					default:
						f_switch.start_stop = 0U;	/* X^[gEXgbv{^ */
						if(f_s.complete == 1U){		/* sV[PX */
							if((e_walk_event != NO_EVW) && (e_walk_event != STOP_EVW)){	/* sJnwL */
								f_s.complete = 0U;
								f_serial.mode_changeable = 0U;/* 샂[hύX */
								e_pc_mode = PC_EXE;/* p\RsԂ */
							}else{
								f_serial.mode_changeable = 1U;/* 샂[hύX */
								e_walk_event = NO_EVW;	/* swF~͏ */
								led_out = LED_OFF;
							}
						}
						break;
					case PC_EXE:		/* p\Rs */
						/* ~D */
						if(f_switch.start_stop == 1U){	/* X^[gEXgbv{^ */
							f_switch.start_stop = 0U;
							e_walk_event = NO_EVW;
							walking_order_event = STOP_EVENT;/* swF~Cxgs */
							f_s.complete = 0U;
							e_pc_mode = PC_STP;	/* p\R~Ԃ */
						}else{
							execute_pc_mode();
						}
						led_out = LED_PULSE;	/* LEDpX_ */
						break;
				}
			}
			break;
		case VB_FAULT:					/* drdُ탂[h (BD3,4) */
		default:
			if((f_vb_alarm.high == 0U) && (f_vb_alarm.low == 0)){/* drd */
			   if(f_switch.start_stop == 1U){/* X^[gEXgbv{^ */
					f_switch.start_stop = 0U;
					f_vb_alarm.abnormal = 0U;	/* drdُ */
					f_serial.respose_pending = 0;	/* m艞M */
					f_vb_control.supply = VB_ON;	/* [^d */
					f_serial.mode_changeable = 1U;	/* 샂[hύX\ */
					shift_mode(BUILTIN_PG);	/* vO샂[hւ̕A */
				}
			}else{					/* drdُ */
				f_switch.start_stop = 0U;	/* X^[gEXgbv{^ */
				f_vb_control.supply = VB_OFF;	/* [^dՒf */
			}
				led_out = LED_BLINK;		/* LED_ */
			break;
	}
}

/* 샂[hύXjbg */
static void shift_mode(enum OP_MODE to_mode){
	struct _F_SYSTEM{
    	unsigned char stop_event_issued:1;			/* ~Cxgsς */
    	unsigned char bit1_7:7;
	};
	static struct _F_SYSTEM f_system = {0,0};		/* ~Cxgsς݃tO */

	/* s~ */
	if(f_s.complete == 1U){
		e_mode_event = NO_EVM;				/* 샂[hύXw */
		switch(to_mode){				/* ύX惂[h */
			case BUILTIN_PG:
				e_operation_mode = BUILTIN_PG;	/* vO샂[h */
				e_builtin_mode = BUILTIN_STP;	/* vO~Ԃ */
				f_serial.walking_motion_changeable = 0U;/* p\R̕sύX */
				break;
			case RX_PG:
				e_operation_mode = RX_PG;	/* ]vO샂[h */
				e_rx_mode = RX_STP;		/* ]vO~Ԃ */
				f_serial.walking_motion_changeable = 0U;/* sύX */
				break;
			case PC_OP:
				e_operation_mode = PC_OP;	/* p\R샂[h */
				e_pc_mode = PC_STP;		/* ]vO~Ԃ */
				f_serial.walking_motion_changeable = 1U;/* sύX */
				break;
			case VB_FAULT:				/* (BD3,4) */
				e_operation_mode = VB_FAULT;	/* drdُ탂[h */
				f_serial.mode_changeable = 0;	/* 샂[hύX */
				f_serial.walking_motion_changeable = 0;	/* sύX */
				f_serial.respose_pending = 0;	/* m艞M */
				break;
		}
		f_switch.start_stop = 0U;			/* p\R샂[h̃XCb`NA */
		walking_order_event_memory = NO_EVENT;		/* swCxgL */
		s16_count_target_request = STOP_COUNTING;	/* ڕWE~ԃJEg~ */
		f_system.stop_event_issued = 0U;		/* [hύX̒~Cxgsς݃tONA */
		if(f_serial.respose_pending == 1U){		/* m艞ۗ */
			f_serial.respose_pending = 0U;		/*  */
			uart0_send_mode_changed();		/* m艞Mi[hύXj */
		}
	}else if(f_system.stop_event_issued == 0U){		/* [hύX̕swF~Cxg͂P̂ݔs */
		f_system.stop_event_issued = 1U;
		walking_order_event = STOP_EVENT;		/* swF~Cxgs */
		f_s.complete = 0U;				/* sV[PXtONA */
		e_builtin_mode = BUILTIN_STP;			/* vO~Ԃ */
		e_rx_mode = RX_STP;				/* MvO~Ԃ */
		e_pc_mode = PC_STP;				/* p\R~Ԃ */
		s16_count_target_request = STOP_COUNTING;	/* vڕWE~ԃJEg𗘗pȂݒ */
	}
}

/* p\Rsjbg */
static void execute_pc_mode(void){
	/* PCMswɑΉCxg𔭍s */
	switch(e_walk_event){
		case FORWARD_EVW:				/* Oiw */
			walking_order_event = FORWARD_EVENT;/* OiCxgs */
			break;
		case RIGHT_EVW:					/* E]w */
			walking_order_event = RIGHT_EVENT;/* E]Cxgs */
			break;
		case BACKWARD_EVW:				/* ގw */
			walking_order_event = BACKWARD_EVENT;/* ރCxgs */
			break;
		case LEFT_EVW:					/* ]w */
			walking_order_event = LEFT_EVENT;/* ]Cxgs */
			break;
		case DANCE_EVW:					/* _Xw */
			walking_order_event = DANCE_EVENT;/* _XCxgs */
			break;
		case NO_EVW:					/* wȂ */
			break;
		case STOP_EVW:					/* ~w */
		/* ẅُ펞~Ԃֈڍs邽 break ȗ */
		default:					/* ُ펞̏ui~j */
			walking_order_event = STOP_EVENT;	/* s~Cxgs */
			e_pc_mode = PC_STP;			/* p\R~ */
			break;
	}
	e_walk_event = NO_EVW;
}

/* s쏇f[^sjbg */
static void execute_sequence_data(struct SEQDATA *seq_data){
	if(sequence_counter >= SQ_NO_MAX){			/* vOV[PXJE^ */
		walking_order_event = STOP_EVENT;		/* swF~Cxgs */
		s16_count_target_request = STOP_COUNTING;	/* vڕWJEg𗘗pȂݒ */
		e_builtin_mode = BUILTIN_STP;			/* vO~Ԃ */
		e_rx_mode = RX_STP;				/* MvO~Ԃ */
	}else{	/* V[PXf[^QƂAsCxg𔭍sJԂ񐔂ݒ肷 */
		switch(seq_data[sequence_counter].category){
			case 0x01:				/* Oi */
				walking_order_event = FORWARD_EVENT;
				s16_count_target_request = seq_data[sequence_counter].count;
				break;
			case 0x02:				/* E] */
				walking_order_event = RIGHT_EVENT;
				s16_count_target_request = seq_data[sequence_counter].count;
				break;
			case 0x04:				/*  */
				walking_order_event = BACKWARD_EVENT;
				s16_count_target_request = -(signed int)seq_data[sequence_counter].count;
				break;
			case 0x08:				/* ] */
				walking_order_event = LEFT_EVENT;
				s16_count_target_request = -(signed int)seq_data[sequence_counter].count;
				break;
			case 0x06:				/* _X */
				walking_order_event = DANCE_EVENT;
				s16_count_target_request = seq_data[sequence_counter].count;
				break;
			case 0x0F:				/* ~ */
				walking_order_event = STOP_EVENT;
				s16_count_target_request = 25 * (signed int)(seq_data[sequence_counter].count);
				break;
			case 0x00:				/* V[PXI */
			default:
				walking_order_event = STOP_EVENT;/* swF~Cxgs */
				s16_count_target_request = STOP_COUNTING;/* JEg𗘗pȂ */
				e_builtin_mode = BUILTIN_STP;	/* vO~Ԃ */
				e_rx_mode = RX_STP;		/* MvO~Ԃ */
				break;
		}
		sequence_counter++;				/* vOV[PXJE^v */
	}
}
