/* System	: 񑫕s{bg(walk)
* File		: unit_sequence_data.c
* function	: PʃXebvV[PXpf[^ (BD1,2,5)
* Version	: 1.0
* Date		: 2019/5/7
* CPU		: RL78/G12 ROM:16KB RAM:1.5KB fCLK:24MHz
* IDE		: CS+ for CC V6.01.00 [01 Dec 2017]
* Programmer	: Hajime Sugiyama
* Note		: */

#include "unit_sequence_data.h"

/* piz[|WVj̃pXz` */
const unsigned int u16_pulse_homeposition[4]
	= {M01HOME,M02HOME,M03HOME,M04HOME};
/* eT[{̖ڕWpXݒpz */
unsigned int u16_pulse_width_target[4]
	= {M01HOME,M02HOME,M03HOME,M04HOME};

/*********************************************************/
/* ڕWp̃[^쓮pXꗗ\		 */
/*	eqbT[{[^ւ̐ݒpX̃Zbg	 */
/* 	(p̍j				 */
/* ڕWp̐	PWSET_MAX 17				 */
/*-------------------------------------------------------*/
/*[^ԍ{ No.1, No.2, No.3, No.4}	:ڕWp	 */
const signed int s16_pulse_width[PWSET_MAX][4]
	=	{{    0,    0,    0,    0}	/* 0:	 */
		,{    0,-5000,    0,-5000}	/* 1:XE*/
		,{ 5000,-5000, 5000,-5000}	/* 2:XEO	 */
		,{ 5000,    0, 5000,    0}	/* 3:EO	 */
		,{ 5000, 5000, 5000, 5000}	/* 4:EX	 */
		,{    0, 5000,    0, 5000}	/* 5:EXE*/
		,{-5000, 5000,-5000, 5000}	/* 6:EXO  */
		,{-5000,    0,-5000,    0}	/* 7:O	 */
		,{-5000,-5000,-5000,-5000}	/* 8:XE	 */
		,{    0,-5000, 2000,-5000}	/* 9:XEO*/
		,{    0,    0, 2000,    0}	/* 10:EO*/
		,{    0, 5000, 2000, 5000}	/* 11:EXEO*/
		,{    0, 5000,-2000, 5000}	/* 12:EXEOJ*/
		,{    0,    0,-2000,    0}	/* 13:EOJ*/
		,{    0,-5000,-2000,-5000}	/* 14:XEOJ*/
		,{-5000,    0,-5000,    0}	/* 15:E */
		,{ 5000,    0, 5000,    0}};	/* 16: */
/*				pXZbgԍ		 */
/*********************************************************/

/*********************************************************/
/* PʃXebvV[PX̎se[u		 */
/* @EPʃXebvV[PX̃Xebv		 */
/* @EPʃXebvV[PXf[^z[]		 */
/*		={ڕWpԍ,pڍs}	 */
/* 					(񐔁~20ms)	 */
/*-------------------------------------------------------*/
/* Oi */
const unsigned int u16_forward_firststep_right[3][2]	/* OiJniEOցj */
	=	{{ 1, 15},{ 2, 15},{ 3, 15}};
const unsigned int u16_forward_firststep_left[3][2]	/* OiJniOցj */
	=	{{ 5, 15},{ 6, 15},{ 7, 15}};
const unsigned int u16_forward_left[4][2]		/* OipiOցj */
	=	{{ 4, 15},{ 5, 15},{ 6, 15},{ 7, 15}};
const unsigned int u16_forward_right[4][2]		/* OipiEOցj */
	=	{{ 8, 15},{ 1, 15},{ 2, 15},{ 3, 15}};
const unsigned int u16_forward_break_left[3][2]		/* OiIij */
	=	{{ 4, 15},{ 5, 15},{ 0, 15}};
const unsigned int u16_forward_break_right[3][2]	/* OiIiEj */
	=	{{ 8, 15},{ 1, 15},{ 0, 15}};
/*---------------------------------------------------------*/
/* E] */
const unsigned int u16_rotate_right_firststep_left[3][2]/* E]JniグOj */
	=	{{ 5, 15},{ 11, 15},{ 10, 15}};
const unsigned int u16_rotate_right_firststep_right[3][2]/* E]JniEグOJj */
	=	{{ 1, 15},{ 14, 15},{ 13, 15}};
const unsigned int u16_rotate_right_right[3][2]		/* E]piEグOJj */
	=	{{ 9, 15},{ 14, 15},{ 13, 15}};
const unsigned int u16_rotate_right_left[3][2]		/* E]piグOj */
	=	{{ 12, 15},{ 11, 15},{ 10, 15}};
const unsigned int u16_rotate_right_break_left[3][2]	/* E]Iij */
	=	{{ 12, 15},{ 5, 15},{ 0, 15}};
const unsigned int u16_rotate_right_break_right[3][2]	/* E]IiEj */
	=	{{ 9, 15},{ 1, 15},{ 0, 15}};
/*---------------------------------------------------------*/
/*  */
const unsigned int u16_backward_firststep_right[3][2]	/* ފJniEցj */
	=	{{ 1, 15},{ 8, 15},{ 7, 15}};
const unsigned int u16_backward_firststep_left[3][2]	/* ފJniցj */
	=	{{ 5, 15},{ 4, 15},{ 3, 15}};
const unsigned int u16_backward_left[4][2]		/* ތpiցj */
	=	{{ 6, 15},{ 5, 15},{ 4, 15},{ 3, 15}};
const unsigned int u16_backward_right[4][2]		/* ތpiEցj */
	=	{{ 2, 15},{ 1, 15},{ 8, 15},{ 7, 15}};
const unsigned int u16_backward_break_left[3][2]	/* ޏIij */
	=	{{ 6, 15},{ 5, 15},{ 0, 15}};
const unsigned int u16_backward_break_right[3][2]	/* ޏIiEj */
	=	{{ 8, 15},{ 1, 15},{ 0, 15}};
/*---------------------------------------------------------*/
/* ] */
const unsigned int u16_rotate_left_firststep_left[3][2]	/* ]JniグOJj */
	=	{{ 5, 15},{ 12, 15},{ 13, 15}};
const unsigned int u16_rotate_left_firststep_right[3][2]/* ]JniEグOj */
	=	{{ 1, 15},{ 9, 15},{ 10, 15}};
const unsigned int u16_rotate_left_right[3][2]		/* ]piEグOj */
	=	{{ 14, 15},{ 9, 15},{ 10, 15}};
const unsigned int u16_rotate_left_left[3][2]		/* ]piグOJj */
	=	{{ 11, 15},{ 12, 15},{ 13, 15}};
const unsigned int u16_rotate_left_break_right[3][2]	/* ]IiEj */
	=	{{ 14, 15},{ 1, 15},{ 0, 15}};
const unsigned int u16_rotate_left_break_left[3][2]	/* ]Iij */
	=	{{ 11, 15},{ 5, 15},{ 0, 15}};
/*---------------------------------------------------------*/
/* _X */
const unsigned int u16_dance[4][2]			/* _X */
	=	{{ 15, 15},{ 0, 15},{ 16, 15},{ 0, 15}};
