/* System	: 񑫕s{bg(walk)
* File		: vb_detect.c
* function	: drd͌m (BD3,4)
* Version	: 1.0
* Date		: 2019/5/7
* CPU		: RL78/G12 ROM:16KB RAM:1.5KB fCLK:24MHz
* IDE		: CS+ for CC V6.01.00 [01 Dec 2017]
* Programmer	: Hajime Sugiyama
* Note		: */

/* @\WX^iSFRjւ̃ANZXLqgp(RL78/R5F1026A) */
#include "iodefine.h"
#include "vb_detect.h"

#pragma interrupt adc_interrupt(vect=INTAD)

/* drdliR@7.5kiVBjF2.2kiGNDj */
#define VB_UPPER_LIMIT	0x03E0			/* [^d 6.01V */
#define VB_LOWER_LIMIT	0x02D0			/* [^d 4.5V */

struct _F_VB_ALARM f_vb_alarm = {0,0,0,0};	/* drdُx */
static unsigned char u8_fadc = 0U;		/* A/DϊtO */

/* drd͌mjbg(BD3,4) */
void init_vb_detect(void){
	/* drdA/DRo[^͏ */
	ADCEN = 1U;				/* A/DRo[^ɃNbN */
	ADPC = 0x02;				/* ANI0/P20 AiO͂ɐݒ */
						/* P21-P23 fW^o͂ɐݒ */
	ADMK = 1U;  				/* disable INTAD interrupt */
	ADIF = 0U;  				/* clear INTAD interrupt flag */
	/* Set INTAD low priority */
	ADPR1 = 1U;
	ADPR0 = 1U;
	PM2_bit.no0 = 1U;			/* ANI0/P20 |[g̓[hɐݒ */
	ADM0 = 0x28;				/* 10rbgϊԁF3.96s */
	ADM1 = 0x20;				/* \tgEFAgKEVbgϊ[h */
	ADM2 = 0x80;				/* d(1.45V)gp */
	ADUL = 0xFF;				/* A/D INT d(8rbg) */
	ADLL = 0x00;				/* A/D INT d(8rbg) */
	ADS = 0x00;				/* ̓`l ANI0 */
}

/* A/DdRp[^싖jbg(BD3,4) */
void enable_vbad(void){
	ADCE = 1U;				/* enable AD comparator */
	/* ADM2ADREFP1, ADREFP0 = 1, 0ɕύXꍇ120NbN(24MHz)ȏ̃EFCgKv */
}

/* drd͌mjbg(BD3,4) */
void vb_detect(void){
	auto unsigned int u16_vb_temp = 0U;	/* obt@ */
	static unsigned int u16_vb_average = 0U;/* ϒl */
	static unsigned int u16_vb_sum = 0U;	/* ݐϒl */
	static unsigned int u16_vb_max = 0U;	/* ől */
	static unsigned int u16_vb_min = 0xFFFF;/* ŏl */
	static unsigned char u8_vb_count = 0U;	/* 擾f[^JE^ */
	if(u8_fadc == 1U){			/* A/DϊH */
		u8_fadc = 0U;

		/* A/Dϊ~ */
		ADCS = 0U;			/* disable AD conversion */
		ADMK = 1U;			/* disable INTAD interrupt */
		ADIF = 0U;			/* clear INTAD interrupt flag */

		u16_vb_temp = ADCR >> 6U;	/* A/Dϊʉ10rbgi[ */
		u16_vb_sum = u16_vb_sum + u16_vb_temp;	/* A/Dlݐ */
		if(u16_vb_temp > u16_vb_max){	/* őlL */
			u16_vb_max = u16_vb_temp;
		}
		if(u16_vb_temp < u16_vb_min){	/* ŏlL */
			u16_vb_min = u16_vb_temp;
		}
		if(++u8_vb_count >= 10){	/* 10f[^擾H */
			u8_vb_count = 0U;
			/* őlƍŏl8f[^ŕϒlZo */
			u16_vb_average = (u16_vb_sum - u16_vb_max - u16_vb_min) >> 3;
			u16_vb_sum = 0U;
			if(u16_vb_average > VB_UPPER_LIMIT){/* 6.0V𒴂 */
				f_vb_alarm.high = 1U;/* drd */
				f_vb_alarm.abnormal = 1U;/* drdُ */
			}else{			/* 6.0Vȓł */
				f_vb_alarm.high = 0U;/* drdNA */
			}
			if(u16_vb_average < VB_LOWER_LIMIT){/* 4.5Vł */
				f_vb_alarm.low = 1U;/* drd */
				f_vb_alarm.abnormal = 1U;/* drdُ */
			}else{			/* 4.5Vȏł */
				f_vb_alarm.low = 0U;/* drdNA */
			}
		}
	}

	/* A/DϊJn */
	ADIF = 0U;  /* clear INTAD interrupt flag */
	ADMK = 0U;  /* enable INTAD interrupt */
	ADCS = 1U;  /* enable AD conversion */
}

static void adc_interrupt(void){		/* A/Dϊjbg(BD3,4) */
	u8_fadc = 1U;				/* A/DϊtOZbg */
}
